
;setting up usefull variables

;for IO

@DEFINE		portA	10
@DEFINE		portB	11
@DEFINE		portC	12
@DEFINE		portD	13
@DEFINE		portE	14
@DEFINE		portF	15
@DEFINE		portG	16
@DEFINE		portH	17

@DEFINE		portAIO	18
@DEFINE		portBIO	19
@DEFINE		portCIO	1A
@DEFINE		portDIO	1B
@DEFINE		portEIO	1C
@DEFINE		portFIO	1D
@DEFINE		portGIO	1E
@DEFINE		portHIO	1F

;for big external screen

@DEFINE 	screenPos 40
@DEFINE 	screenData 41




;setting which GPIO should be in or out
loadl 0
movel 2|11111110 portAIO
movel 16|00 portBIO
movel 16|FF portCIO
movel 16|FF portDIO
movel 16|FF portEIO
movel 16|FF portFIO
movel 16|FF portGIO
movel 16|FF portHIO
movel 2|00011111 compReg
movel 0 portA




call @clrscr
call @clrPage ; setting up starting message
movel "H" 20
movel "E" 21
movel "L" 22
movel "L" 23
movel "O" 24
movel "W" 34
movel "O" 35
movel "R" 36
movel "L" 37
movel "D" 38
call @ultrawait
call @ultrawait
call @ultrawait
call @ultrawait
call @clrscr
movel "P" 20 ; setting up runtime message
movel "O" 21
movel "S" 22
movel "I" 23
movel "T" 24
movel "I" 25
movel "O" 26
movel "N" 27
movel " " 28
movel "O" 29
movel "F" 2A
movel " " 2B
movel "D" 2C
movel "O" 2D
movel "T" 2E
movel " " 2F

movel "d" 30
movel "'" 31
movel " " 32
movel " " 33
movel " " 34
movel "'" 35
movel " " 36
movel "0" 37
movel "x" 38
movel " " 39
movel " " 3A
movel " " 3B
movel " " 3C
movel " " 3D
movel " " 3E
movel " " 3F




start:
	

	call @moveDot
	move reg0 ALU

	call @base10 ; converting the position of the don to base 10 text string
	move 34 reg1 ; and drawing it to the small screen
	move 33 reg2
	move 32 reg3

	call @base16 ; same but with base 16
	move 39 reg1
	move 3A reg2


	call @ultrawait ; waiting
	call @ultrawait
	; call @ultrawait
	; call @ultrawait

jump @start




clrscr: ; clears the small screen
	movel " " 20
	movel " " 21
	movel " " 22
	movel " " 23
	movel " " 24
	movel " " 25
	movel " " 26
	movel " " 27
	movel " " 28
	movel " " 29
	movel " " 2A
	movel " " 2B
	movel " " 2C
	movel " " 2D
	movel " " 2E
	movel " " 2F
	movel " " 30
	movel " " 31
	movel " " 32
	movel " " 33
	movel " " 34
	movel " " 35
	movel " " 36
	movel " " 37
	movel " " 38
	movel " " 39
	movel " " 3A
	movel " " 3B
	movel " " 3C
	movel " " 3D
	movel " " 3E
	movel " " 3F
return


clrPage: ; clears the big screen
	movel 0 ALU
	movel 0 compReg
	pageloop:
		move screenPos ALU
		move reg0 ALU
		addl 1
		movel " " screenData
		
	jumpc greaterThan @pageloop
return



@DEFINE dotPos AB

moveDot:
	rand ; determine horizontal velocity
	andl 0F
	modl 3
	subl 1
	andl 0F
	move reg0 ALU

	rand ; determine vertical velocity
	andl 0F
	modl 3
	subl 1
	andl 0F
	move reg1 ALU
	
	move screenPos dotPos ; clearing old pos
	movel FE screenData
	

	move ALU dotPos ; adding horizon vel
	andl 0F
	add reg0
	andl 0F
	move reg0 ALU

	move ALU dotPos ; adding vertical vel
	andl F0
	brotrl 4
	add reg1
	andl 0F
	brotll 4


	or reg0 ; combining the two
	
	move screenPos ALU ; setting new pos
	movel DB screenData
	move dotPos ALU
return




base16: ; convert value in reg0 to base 16 string stored in reg1(lsd) reg2(msd)
	;least significant digit
	move ALU reg0
	andl 16|0F
	addl 16|30
	movel 16|3A compReg
	jumprc lessThan 2
	addl 7
	move reg1 ALU

	;most significant digit
	move ALU reg0
	andl 16|F0
	brotrl 4
	addl 16|30
	movel 16|3A compReg
	jumprc lessThan 2
	addl 7
	move reg2 ALU
return




base10: ; convert value in reg0 to base 10 string stored in reg1(lsd) reg2(md) reg3(msd)
	;least significant digit
	move ALU reg0
	modl 10|10
	addl 30
	move reg1 ALU

	;middle digit
	move ALU reg0
	divl 10|10
	modl 10|10
	addl 30
	move reg2 ALU

	;most significant digit
	move ALU reg0
	divl 10|100
	modl 10|10
	addl 30
	move reg3 ALU
return




wait: ; small waiting routine
	movel 0 compReg
	move ALU reg0
	loop:
		subl 1
	jumpc greaterThan @loop
return

ultrawait: ; large waiting routine
	movel FF reg0
	call @wait
	movel FF reg0
	call @wait
	movel FF reg0
	call @wait
	movel FF reg0
	call @wait
	movel FF reg0
	call @wait
	movel FF reg0
	call @wait
	movel FF reg0
	call @wait
	movel FF reg0
	call @wait
	movel FF reg0
	call @wait
return


trap:   ; trap if code gets out of controll
movel 16|ff portA
movel 16|00 portA
jump @trap
